/*
 *******************************
 *TAREA 2
 *PROGRAMACION DE SISTEMAS
 *PROF: AGUSTIN GONZALEZ
 *AUTOR: EDUARDO GONZALEZ FISHER
 *ROL:   2021010-9
 *******************************
 */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

int matriz[10][10];
FILE *tmp;

int check_matrix(int,int);
void create_crux();
void ingresar_portaavion();
void ingresar_fragata();
void ingresar_submarino();

int main(int argc, char *argv[])
{
    pid_t pid;
    int pfd[2];
    int i,j, status;
    FILE * sd;
    int posx=0, posy=0;
    int valido = 1;
    int opc[]={9,9};


    /*Verificar el ingreso de parametros*/
    if ( argc == 4) {
      if ( fopen(argv[1],"r")  == NULL ) {
	printf("Archivo de texto (\"%s\") inexistente\nUso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino]\n",argv[1],argv[0]);
	exit(-1);
      }
      if ( fopen(argv[2],"r") == NULL ) {
	printf("Archivo de texto (\"%s\") inexistente\nUso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino]\n",argv[2],argv[0]);
	exit(-1);
      }
      if ( fopen(argv[3],"r") == NULL ) {
	printf("Archivo de texto (\"%s\") inexistente\nUso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino]\n",argv[3],argv[0]);
	exit(-1);
      }
    }
    else {
      printf("\nIngrese como argumento los nombres de archivos de texto\n> ");
      printf("Uso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino]\n",argv[0]);
      exit(-1);
    }

    /* llenar la matriz */
    for(i=0;i<10;i++)
      for(j=0;j<10;j++)
	matriz[i][j] = 0;


    /****** crea la cruz *********/
    create_crux();

    /*
     * Create a pipe.
     */
    if (pipe(pfd) < 0) {
        perror("pipe");
        exit(1);
    }

    /*
     * Create a child process.
     */
    if ((pid = fork()) < 0) {
        perror("fork");
        exit(1);
    }

    /*
     * The child process executes "gnuplot".
     */
    if (pid == 0) {
        /*
         * Attach standard input of this child process to read from the pipe.
         */
        dup2(pfd[0], 0);
        close(pfd[1]);  /* close the write end off the pipe */
        execlp("gnuplot", "gnuplot", 0);
        perror("exec");
        _exit(127);
    }

    /*
     * We won't be reading from the pipe.
     */
    close(pfd[0]);
    sd = fdopen(pfd[1], "w");
    /*
     * Write our command message to the pipe.
     */
    fprintf(sd, "set xrange [0:999]\n");
    fprintf(sd, "set yrange [0:999]\n");
    fprintf(sd, "set xtics border nomirror (\"0\" 50,\"1\" 150,\"2\" 250,\"3\" 350,\"4\" 450,\"5\" 550,\"6\" 650,\"7\" 750,\"8\" 850,\"9\" 950)\n");
    fprintf(sd, "set ytics border nomirror rotate (\"0\" 50,\"1\" 150,\"2\" 250,\"3\" 350,\"4\" 450,\"5\" 550,\"6\" 650,\"7\" 750,\"8\" 850,\"9\" 950)\n");
    fprintf(sd, "set x2tics 50, 100\n");
    fprintf(sd, "set y2tics 50, 100\n");
    fprintf(sd, "set mx2tics 2\n");
    fprintf(sd, "set my2tics 2\n");
    fprintf(sd, "set format x2 \"\"; set format y2 \"\"\n"); // elimina la etiqueta de ejes x2 y2
    fprintf(sd, "set grid my2tics mx2tics linetype 0\n");
    fprintf(sd, "set multiplot\n");
    fprintf(sd, "set nokey\n");
    fprintf(sd, "set title \"Batalla Naval v1.0\" \n");
    fprintf(sd, "plot -2\n"); //muestra el campo de batalla
    fprintf(sd, "set parametric\npause -1\n");
    fflush(sd);

    for(;j!=5;) {
      do {
	if (valido==0)
	  printf("Opcion invalida....\n");
	printf("\nSeleccione una opcion:\n0.- Ingresar PortaAviones\n1.- Ingresar Fragata\n2.- Ingresar Submarino\n5.- Continuar\n-> ");
	scanf("%d",&j);
      }while( j<0 || j==4 || j>5 || opc[0]==j || opc[1]==j);

      if (j==0){
	/**********************PORTA AVIONES***************/
	printf("\n");
	do{
	  if (valido==0)
	    printf("Posicion no valida... dibujo queda fuera del area o sobre otro navio.\n");
	  printf("Ingrese la posicion en donde ubicar el portaaviones (x y): ");
	  valido = 0;
	  scanf("%d%d",&posx,&posy);
	} while(posx<0 || posx>7 || posy<0 || posy>9 || check_matrix(posx,posy) || check_matrix(posx+1,posy) || check_matrix(posx+2,posy) );

	matriz[posx][posy] = 1;
	matriz[posx+1][posy] = 1;
	matriz[posx+2][posy] = 1;
	valido = 1;
	fprintf(sd, "\nplot \"%s\" using ($1+%i):($2+%i) with lines  1\n", argv[1], posx*100, posy*100);
	fprintf(sd, "\n"); fflush(sd);
      }
      else {
	if (j==1) {
	  /********** FRAGATA  ***************/
	  do{
	    if (valido==0)
	      printf("Posicion no valida... dibujo queda fuera del area o sobre otro navio.\n");
	    printf("Ingrese la posicion en donde ubicar la fragata (x y): ");
	    valido = 0;
	    scanf("%d%d",&posx,&posy);
	  } while(posx<0 || posx>8 || posy<0 || posy>9 || check_matrix(posx,posy) || check_matrix(posx+1,posy));
	  matriz[posx][posy] = 1;
	  matriz[posx+1][posy] = 1;
	  printf("\n---%d     %d\n",posx,posy);
	  valido = 1;
	  fprintf(sd, "\nplot \"%s\" using ($1+%i):($2+%i) with lines 4\n", argv[2], posx*100, posy*100);
	  fprintf(sd, "\n"); fflush(sd);
	}
	else if (j==2) {
	  /********** SUBMARINO  ***************/
	  do{
	    if (valido==0)
	      printf("Posicion no valida... dibujo queda fuera del area o sobre otro navio.\n");
	    printf("Ingrese la posicion en donde ubicar el submarino fragata (x y): ");
	    valido = 0;
	    scanf("%d%d",&posx,&posy);
	  } while(posx<0 || posx>9 || posy<0 || posy>9 || check_matrix(posx,posy));
	  matriz[posx][posy] = 1;
	  printf("\n---%d     %d\n",posx,posy);
	  valido = 1;
	  fprintf(sd, "\nplot \"%s\" using ($1+%i):($2+%i) with lines 6\n", argv[3], posx*100, posy*100);
	  fprintf(sd, "\n"); fflush(sd);
	}
      }
    }

    /********** DISPAROS ***********/
    printf("\nIngrese la cantidad de disparos: ");
    scanf("%d",&i);
    while (i>0) {
      do{
	if (valido==0)
	  printf("Posicion no valida... fuera del area.\n");
	printf("\nElija Objetivo (x y): ");
	valido = 0;
	scanf("%d%d",&posx,&posy);
      } while(posx<0 || posx>9 || posy<0 || posy>9);
      valido = 1;
      if (check_matrix(posx,posy)==0) { //fallo
	fprintf(sd, "\n");
	fprintf(sd, "plot 30*sin(t)+50+100*%i,30*cos(t)+50+100*%i with points pointtype 7 ps 1 \n",posx,posy); //dibuja circulo
	fprintf(sd, "\n"); fflush(sd);
	printf("\nBuuu... al agua!");
      }
      else { //acerto
	fprintf(sd, "\n");
	fprintf(sd, "plot \"/tmp/miarchivocruz.mio.txt\" using ($1+%i):($2+%i) with lines linetype 2 lw 10\n",posx*100,posy*100); //dibuja cruz
	fprintf(sd, "\n"); fflush(sd);
	printf("\nEn el Blanco!");
      }
      i--;
    }
    fflush(stdin);
    sleep(7);
    fprintf(sd, "\n exit\n"); fflush(sd);

    fclose(sd);
    waitpid(pid, &status, 0);

    /*
     * Exit with a status of 0, indicating that
     * everything went fine.
     */
    printf("\n\tF\tI\tN\n");
    remove("/tmp/miarchivocruz.mio.txt");
    exit(0);
}

int check_matrix(int x, int y){
  return matriz[x][y];
}

void create_crux() {
  tmp = fopen("/tmp/miarchivocruz.mio.txt","w+");
  fprintf(tmp,"10\t10\n");
  fprintf(tmp,"90\t90\n");
  fprintf(tmp,"50\t50\n");
  fprintf(tmp,"10\t90\n");
  fprintf(tmp,"90\t10\n");
  fclose(tmp);
  return;
}
